[leetcode]【数组】33. Search in Rotated Sorted Array

来源:互联网 发布:win10ie无法下载软件 编辑:程序博客网 时间:2024/06/08 04:15

Suppose a sorted array is rotated at some pivot unknown to you beforehand.

(i.e., 0 1 2 4 5 6 7 might become 4 5 6 7 0 1 2).

You are given a target value to search. If found in the array return its index, otherwise return -1.

You may assume no duplicate exists in the array.

题解

题意是说一个排好序的数组,经过一定的循环位移,变成新的数组。
并且假设没有重复元素。
最简单的方法,当然是遍历一遍数组,这样的事件复杂度是n级。
这里我介绍的是二分法。因为是排好序的,所以通过二分,数组肯定有一边是排好序的,一边是混合的。比如3 4 5 6 7 0 1 2,分开之后是3 4 5 6和7 0 1 2. 明显前半部是排好序的。这样就可以根据target与其关系进行判断target处于哪个部分。这样进行二分查找的复杂度就是log n

//cppclass Solution {public:    int search(vector<int>& nums, int target) {        int head=0,tail=nums.size();        while(head!=tail)        {            int mid=(head+tail)/2;            if(nums[mid]==target)                return mid;            if(nums[head]<=nums[mid])            {                if(target>=nums[head]&&target<nums[mid])                    tail=mid;                else head=mid+1;            }            else            {                if(target>nums[mid]&&target<=nums[tail-1])                    head=mid+1;                else tail=mid;            }        }        return -1;    }};
0 0